// actual grading of fictitious single-choice exam data


**##2.1 Translate answers to points
**---------------------------------
forvalues i = 1/$question_ct {
	
	generate byte points_question_`i' =  ///
        (question_`i' == "${question_`i'}") * $question_pt
}




**##2.2 Totals & percentages
**--------------------------
egen int total = rowtotal(points_question_*)


generate percent = total/($question_ct*$question_pt) * 100
format percent %6.2f




**##2.3 Convert to grades
**-----------------------

quietly: generate grade = ""


if "$grading" == "points"  {
	local criterion = "total"
    local unit      = "pts."
}

else {
	local criterion = "percent"
    local unit      = "%"
}

local i = 1
foreach value of global $grading {
	local grade :word `i' of $grades
    
	display "  {res}`value' {txt} `unit' -> grade: {res}`grade'"
    
	quietly: replace grade = "`grade'"  if (`criterion' >= `value') & missing(grade)
    
    local ++i
}


assert !missing(grade)  // check: each participant assigned a grade
exit